#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <strings.h>
#include <stdlib.h>
#include <string.h>

#define SERVER_PORT 7111
#define LEN_RECVBUFFER 1000
#define SERVER_IP_ADDRESS "127.0.0.1"

static int parent(int sfd, int childpid) {
  ssize_t len, lensent, wlen;
  char sendbuffer[LEN_RECVBUFFER];

  //Vater
  while ( 1 ) {

    //Einlesen
    len = read(STDIN_FILENO, sendbuffer, LEN_RECVBUFFER-2);
    if (len == -1) {
      perror("read()-call");
      return 1;
    } else if (len == 0) {
      // EOF
      len = strlen("STOP");
      strcpy(sendbuffer, "STOP");
    }
    sendbuffer[len] = '\n';
    sendbuffer[len+1] = '\0';
    len = len + 1;
    lensent = 0;
    
    //Senden
    while ( lensent < len ) {
      wlen = send(sfd, sendbuffer + lensent, len - lensent, 0);
      if (wlen < 0) {
        perror("write()-call");
        return 1;
      } else {
        lensent = lensent + wlen;
      }
    }
    // Bei Eingabe von STOP wird der Client beendet
    if ( !strncmp(sendbuffer,"STOP",strlen("STOP")) ) {
      if(0 > kill(childpid, SIGTERM)) {
        perror("Problem with kill()");
        return 1;
      }
      break;
    }
  }
  return 0;
}

static int child(int sfd) {
  char recvbuffer[LEN_RECVBUFFER+1];
  ssize_t lenrecv;
  while (1) {
    //lesen
    lenrecv = recv(sfd, recvbuffer, LEN_RECVBUFFER, 0);
    if (lenrecv < 0) {
      perror("read()-call");
      return 1;
    } else if (lenrecv == 0) {
      // connection closed
      break;
    } else {
      recvbuffer[lenrecv] = '\0';
      printf("Empfange %s",recvbuffer);
      fflush(NULL);
    }
  }
  return 0;
}

int main() {
  int ret;
  int sfd;
  struct  sockaddr_in saddr;
  pid_t childpid;

  if ( 0 > ( sfd = socket(PF_INET,SOCK_STREAM,0) ) ) {
    perror("socket()-call");
    return 1;
  }

  memset((char *)&saddr, 0, sizeof(saddr));
  saddr.sin_family = AF_INET;
  /*--- als IP adresse muss der String, zB 192.168.50.99
    in die 32-Bit Binaerreprsentation transformiert werden-*/
  saddr.sin_addr.s_addr = inet_addr(SERVER_IP_ADDRESS);
  saddr.sin_port = htons(SERVER_PORT);

  //Verbindung mit dem Server aufnehmen
  if ( -1 == (connect(sfd,
                      (struct sockaddr *)&saddr,
                      sizeof(saddr) )) ) {
    perror("connect()-call");
    return 1;
  }

  //Aufteilung in Kind- und Vaterprozess
  if ( 0 > (childpid = fork()) ) {
    perror("fork()-call");
    return 1;
  }

  if ( !childpid ) {
    ret = child(sfd);
  } else {
    ret = parent(sfd, childpid);
  }

  close(sfd);
  return ret;  
}
